package com.jiuqi.util.tree;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.util.tree.TreeNode;
import java.util.Iterator;
import java.util.Stack;

class TreeIterator implements Iterator {
  private Stack stack;
  
  public TreeIterator(TreeNode root) {
    this.stack = new Stack();
    this.stack.push(new NodeStub(root, 0));
  }
  
  public boolean hasNext() {
    while (!this.stack.empty()) {
      NodeStub prev = this.stack.peek();
      if (prev.next < prev.node.size())
        return true; 
      this.stack.pop();
    } 
    return false;
  }
  
  public Object next() {
    while (!this.stack.empty()) {
      NodeStub prev = this.stack.peek();
      if (prev.next < prev.node.size()) {
        TreeNode nextNode = prev.node.get(prev.next);
        if (nextNode.size() > 0)
          this.stack.push(new NodeStub(nextNode, 0)); 
        prev.next++;
        return nextNode.getItem();
      } 
      this.stack.pop();
    } 
    return null;
  }
  
  public void remove() {
    throw new UnsupportedOperationException("树形枚举器不支持删除操作！");
  }
}
